package com.flyfish.framework.approval.auditor;

import com.flyfish.framework.approval.domain.record.ApproveRecord;
import com.flyfish.framework.auditor.ReactiveBeanAuditor;
import org.springframework.stereotype.Component;
import reactor.core.publisher.Mono;

@Component
public class ApproveRecordAuditor implements ReactiveBeanAuditor<ApproveRecord> {

    /**
     * 对实体进行审查，并补全相关字段
     *
     * @param data 原数据
     * @return 结果
     */
    @Override
    public Mono<ApproveRecord> audit(ApproveRecord data) {
        if (null != data.getAction()) {
            if (null == data.getApproved()) {
                data.setApproved(true);
            }
        }
        return Mono.just(data);
    }
}
