package com.flyfish.framework.validation.validators;

import com.flyfish.framework.validation.annotations.IsJSONString;
import org.apache.commons.lang3.StringUtils;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;

/**
 * 是否是jsonString
 *
 * @author wangyu
 */
public class IsJSONStringValidator implements ConstraintValidator<IsJSONString, String> {

    /**
     * 是否是可用的
     *
     * @param value                      值
     * @param constraintValidatorContext 上下文
     * @return 结果
     */
    @Override
    public boolean isValid(String value, ConstraintValidatorContext constraintValidatorContext) {
        if (StringUtils.isBlank(value)) return true;
        return value.startsWith("{") && value.endsWith("}")
                || value.startsWith("[") && value.endsWith("]");
    }
}
