package com.flyfish.framework.annotations;

import java.lang.annotation.*;

/**
 * 动作，描述一个操作
 *
 * @author wangyu
 */
@Target({ElementType.METHOD, ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface Operation {

    /**
     * 动作名称，可选静态变量池和字符串
     *
     * @return 结果
     */
    String value();

    /**
     * 模块名，描述模块，如果为空自动获取bean的rest-bean注解
     *
     * @return 结果
     */
    String module() default "";

    /**
     * 内置类型
     */
    @Target(ElementType.METHOD)
    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @Operation("CREATE")
    @interface Create {

    }

    @Target(ElementType.METHOD)
    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @Operation("UPDATE")
    @interface Update {

    }

    @Target(ElementType.METHOD)
    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @Operation("UPDATE_ALL")
    @interface UpdateAll {

    }

    @Target(ElementType.METHOD)
    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @Operation("DELETE")
    @interface Delete {

    }

    @Target(ElementType.METHOD)
    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @Operation("SYNC")
    @interface Sync {

    }
}
