package com.flyfish.framework.repository.factory;

import org.springframework.data.mongodb.core.ReactiveMongoOperations;
import org.springframework.data.mongodb.repository.support.ReactiveMongoRepositoryFactoryBean;
import org.springframework.data.repository.Repository;
import org.springframework.data.repository.core.support.RepositoryFactorySupport;
import org.springframework.lang.NonNull;

public class DefaultReactiveRepositoryFactoryBean<T extends Repository<S, String>, S>
        extends ReactiveMongoRepositoryFactoryBean<T, S, String> {

    /**
     * Creates a new {@link ReactiveMongoRepositoryFactoryBean} for the given repository interface.
     *
     * @param repositoryInterface must not be {@literal null}.
     */
    public DefaultReactiveRepositoryFactoryBean(Class<? extends T> repositoryInterface) {
        super(repositoryInterface);
    }

    @Override
    @NonNull
    protected RepositoryFactorySupport getFactoryInstance(@NonNull ReactiveMongoOperations operations) {
        return new DefaultReactiveRepositoryFactory(operations);
    }
}
